package com.neolix.cubingsdk.utils;

import android.util.Log;

import java.math.RoundingMode;
import java.text.NumberFormat;
import java.util.ArrayList;

public class Util {
    /**
     * 格式化小数， 保留多少位
     * @param number
     * @param digits
     * @return
     */
    public static float getFormatNumber(float number, int digits) {
        NumberFormat nf = NumberFormat.getNumberInstance();
        nf.setMaximumFractionDigits(digits);
        nf.setRoundingMode(RoundingMode.UP);
        return Float.parseFloat(nf.format(number));
    }

    public static double getAverage(int[] data){
        int sum = 0;
        for(int i=0; i<data.length; i++){
            sum += data[i];
        }
        return sum/data.length;
    }

    public static double getSqrt(int[] data){
        float sumSqu = 0;
        double aveVulue = getAverage(data);
        for(int i=0; i<data.length;i++){
            sumSqu += Math.pow(data[i]-aveVulue,2);
        }
        return Math.sqrt(sumSqu/(data.length-1));
    }

    public static ArrayList<Integer> filterAbnormalData(int[] original){
        double result  = 1*getSqrt(original);
        double avevalue = getAverage(original);
        ArrayList<Integer> errorIndex = new ArrayList<>();
        for(int i=0; i< original.length; i++){
            double temp = Math.abs(original[i] - avevalue-result);
            if(temp >0){
                errorIndex.add(i);
                Log.e("niuwenchao","error:"+original[i]);
            }
        }
        return  errorIndex;
    }
    /**
     * 格式化小数， 保留多少位
     * @param number
     * @param digits
     * @return
     */
    public static String getFormatNumberToString(float number, int digits) {
        NumberFormat nf = NumberFormat.getNumberInstance();
        nf.setGroupingUsed(false);
        nf.setMaximumFractionDigits(digits);
        nf.setRoundingMode(RoundingMode.DOWN);
        return nf.format(number);
    }
}
