package com.neolix.mdm.entity;

import android.os.Parcel;
import android.os.Parcelable;
import android.support.annotation.NonNull;

public class AppData implements Parcelable {

    @NonNull
    public String appPackage;
    public String appName;
    public String appVersion;
    public String packageUrl;
    public String logo; // App Icon
    public int pageNum; // index of the current page
    public int pageSize; // the count of All the elements int the current page
    public int total;   // All apps count
    public int pages;   // All pages count
    public String path; // download path
    public String baseUrl; //rerofit base url
    public String suffixName; // apk name
    public String updateVersion;
    public int appState = READY; // 0 ready download 1 downloading 2 downloaded 3 installing 4 installed

    public static final int READY = 0;
    public static final int DOWNLOADING = 1;
    public static final int INSTALLING = 2;
    public static final int UPGRADE = 3;

    public AppData() {
    }

    @Override
    public String toString() {
        return "AppData{" +
                "appPackage='" + appPackage + '\'' +
                ", appName='" + appName + '\'' +
                ", appVersion='" + appVersion + '\'' +
                ", packageUrl='" + packageUrl + '\'' +
                ", logo='" + logo + '\'' +
                ", pageNum=" + pageNum +
                ", pageSize=" + pageSize +
                ", total=" + total +
                ", pages=" + pages +
                ", path='" + path + '\'' +
                ", baseUrl='" + baseUrl + '\'' +
                ", suffixName='" + suffixName + '\'' +
                ", appState=" + appState +
                '}';
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(this.appPackage);
        dest.writeString(this.appName);
        dest.writeString(this.appVersion);
        dest.writeString(this.packageUrl);
        dest.writeString(this.logo);
        dest.writeInt(this.pageNum);
        dest.writeInt(this.pageSize);
        dest.writeInt(this.total);
        dest.writeInt(this.pages);
        dest.writeString(this.path);
        dest.writeString(this.baseUrl);
        dest.writeString(this.suffixName);
        dest.writeString(this.updateVersion);
        dest.writeInt(this.appState);
    }

    protected AppData(Parcel in) {
        this.appPackage = in.readString();
        this.appName = in.readString();
        this.appVersion = in.readString();
        this.packageUrl = in.readString();
        this.logo = in.readString();
        this.pageNum = in.readInt();
        this.pageSize = in.readInt();
        this.total = in.readInt();
        this.pages = in.readInt();
        this.path = in.readString();
        this.baseUrl = in.readString();
        this.suffixName = in.readString();
        this.updateVersion = in.readString();
        this.appState = in.readInt();
    }

    public static final Creator<AppData> CREATOR = new Creator<AppData>() {
        @Override
        public AppData createFromParcel(Parcel source) {
            return new AppData(source);
        }

        @Override
        public AppData[] newArray(int size) {
            return new AppData[size];
        }
    };
}
